// soundwave.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "soundwave.h"

#define MAX_LOADSTRING 100

#ifndef UNICODE
#error no ansi
#endif


// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void                OnOpenFile(HWND parent);
void DoPaint(HWND hWnd, HDC pdc);

// extracted uncompressed signal (PCM, 16 bits per sample)
short* g_pWave = 0;
ULONG g_nFrames; // how many samples (depends on sampling frequency)
ULONG g_maxValue; // plotting range
#define MAX_AUDIO_DURATION_MSEC 5000 
// extracts one channel from the audio stream
short* MFGetUncompressedWave(LPCTSTR file, DWORD duration, HWND hwnd, ULONG& frames, HRESULT &hr);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_SOUNDWAVE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_SOUNDWAVE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if(g_pWave)
		free(g_pWave);
    MFShutdown();
    CoUninitialize();

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_SOUNDWAVE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_SOUNDWAVE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

    // Initialize the COM library.
    HRESULT hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE);
	ATLASSERT(SUCCEEDED(hr));
    // Intialize the Media Foundation platform.
    hr = MFStartup(MF_VERSION);
   	ATLASSERT(SUCCEEDED(hr));
	if(S_OK != hr)
		return FALSE; // windows XP?

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		case ID_FILE_OPENAUDIO:
			OnOpenFile(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		DoPaint(hWnd, hdc);
		EndPaint(hWnd, &ps);
		break;
	case WM_ERASEBKGND:
        return 1; // done in paint
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

void DoPaint(HWND hwnd, HDC pdc)
{
    RECT rc;
    GetClientRect(hwnd, &rc);
    FillRect(pdc, &rc, (HBRUSH) COLOR_WINDOW);
	if(g_pWave) {
		//draw a line for zero
		int height = (rc.bottom - rc.top)/2;
		MoveToEx(pdc, 0, height, 0);
		LineTo(pdc, rc.right, height);

		// the first part of the song is usually silence, so skip to the beginning of it
		int i = 0;
		while(g_pWave[i] < (int)g_maxValue/10)
			i++;
		ATLASSERT(i < g_nFrames);
		int imax = i+rc.right;
		if(imax > g_nFrames)
			imax = g_nFrames;

		HPEN hPen = CreatePen(PS_SOLID, 1, RGB(0,0,255));
      SelectObject(pdc, hPen);
		int left = 0;
		MoveToEx(pdc, 0, height, 0);
		for( ; i<imax; i++, left++) {
			// the scale of the Y axis is [-g_maxValue, +g_maxValue]
			int y = MulDiv(g_pWave[i],height,g_maxValue);
			// GDI paint origin is TOP left window corner
			LineTo(pdc, left, height - y);
		}
		ATLASSERT(left <= rc.right);
		DeleteObject(hPen);
	}
}
	
// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

void OnOpenFile(HWND parent)
{
    OPENFILENAME ofn;       // common dialog box structure
    WCHAR  szFile[260];       // buffer for file name
//    HWND hwnd;              // owner window

    // Initialize OPENFILENAME
    ZeroMemory(&ofn, sizeof(ofn));
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = parent;
    ofn.lpstrFile = szFile;
    // Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
    // use the contents of szFile to initialize itself.
    ofn.lpstrFile[0] = '\0\0';
    ofn.nMaxFile = sizeof(szFile);
    ofn.lpstrFilter = L"music files\0*.mp3;*.wma;*.wav;*.flac;*.ac3\0All files\0*.*\0";
    ofn.nFilterIndex = 1;
    ofn.lpstrFileTitle = NULL;
    ofn.nMaxFileTitle = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

    // Display the Open dialog box. 

    if (GetOpenFileName(&ofn)==TRUE) 
    {
		ULONG i, frames = 0;
		HRESULT hr = E_FAIL;
		short* wave = MFGetUncompressedWave(ofn.lpstrFile, MAX_AUDIO_DURATION_MSEC, parent, frames, hr);
		if(!wave) {
			TCHAR buf[1000];
			wsprintf(buf, _T("error opening audio (%x)"), hr);
			MessageBox(parent, buf, 0, MB_OK | MB_ICONERROR);
			return;
		}
		ATLASSERT(SUCCEEDED(hr));

		if(g_pWave)
			free(g_pWave);
		g_pWave = wave;
		g_nFrames = frames;
		// calculate plotting range scale (Y-axis)
		g_maxValue = 0;
		for(i=0; i<frames; i++)
		{
			DWORD positive = wave[i] >= 0 ? wave[i] : -wave[i];
			if(positive > g_maxValue)
				g_maxValue = positive;
		}

		InvalidateRect(parent, 0, TRUE); // repaint
    }
}

// returns sound wave data and implicitly # of frames and error code
// https://docs.microsoft.com/en-us/windows/win32/medfound/tutorial--decoding-audio
short* MFGetUncompressedWave(LPCTSTR file, DWORD duration/*msec*/, HWND hwnd, ULONG& frames, HRESULT &hr)
{
	frames = 0;
	// source reader component automatically opens and decodes all supported media formats
	CComPtr<IMFSourceReader> pReader;
	hr = MFCreateSourceReaderFromURL(file, 0, &pReader);
	if(!pReader)
		return 0;

	// audio files have only one stream (even if stereo, channels are interleaved)
	// if there are any other streams (e.g. from AVI), deselect them
	// no way to count streams, so enumerate till error
	int i=0, naud=0, hz, channels;
	while(1) {
		CComPtr<IMFMediaType> imt;
		hr = pReader->GetNativeMediaType(i, 0, &imt);
		if(!imt)
			break; // no more streams
		
		GUID major;
		hr = imt->GetMajorType(&major);
		if(major==MFMediaType_Audio) {
			naud++;

			hz = MFGetAttributeUINT32(imt, MF_MT_AUDIO_SAMPLES_PER_SECOND, 0);
			ATLASSERT(hz >= 1000); // usually 44100 Hz
			channels = MFGetAttributeUINT32(imt, MF_MT_AUDIO_NUM_CHANNELS, 0);
			ATLASSERT(channels >= 1 || channels <=2); // 1(mono) or 2(stereo)
		}
		else
			hr = pReader->SetStreamSelection(i, 0); // no need to extract video

		i++;
	}
	ATLASSERT(naud <= 1); // can be accessed by MF_SOURCE_READER_FIRST_AUDIO_STREAM
	if(!naud)
		return 0;

	// Configure the source reader to get uncompressed PCM audio from the source file.
	CComPtr<IMFMediaType> pPartialType;
	hr = MFCreateMediaType(&pPartialType);
	if(!pPartialType)
		return 0;

    hr = pPartialType->SetGUID(MF_MT_MAJOR_TYPE, MFMediaType_Audio);
	// to get actual numbers use MFAudioFormat_Float
    hr = pPartialType->SetGUID(MF_MT_SUBTYPE, MFAudioFormat_PCM);
	ATLASSERT(SUCCEEDED(hr));
	if(channels > 1)
		// merge all channels in 1
		hr = pPartialType->SetUINT32(MF_MT_AUDIO_NUM_CHANNELS, 1);
	// if needed you can downsample the native frequency as such
	// @@@ this does NOT work for win7, error 0xC00D36B4, try CLSID_CResamplerMediaObject
	if(0 && hz > 11025) {
		hz = 11025;
		hr = pPartialType->SetUINT32(MF_MT_AUDIO_SAMPLES_PER_SECOND, hz);
	}

	// Set this type on the source reader. The source reader will
    // load the necessary decoder.
    hr = pReader->SetCurrentMediaType(
		(DWORD)MF_SOURCE_READER_FIRST_AUDIO_STREAM, 
        NULL,pPartialType);
	if(FAILED(hr))
		return 0;

	// Get the complete uncompressed format with all details
	CComPtr<IMFMediaType> pUncompressedAudioType;
	hr = pReader->GetCurrentMediaType(
        (DWORD)MF_SOURCE_READER_FIRST_AUDIO_STREAM, 
        &pUncompressedAudioType);
	if(!pUncompressedAudioType)
		return 0;
	// to examine media types, use the logging helpers from here
	// https://docs.microsoft.com/en-us/windows/win32/medfound/media-type-debugging-code

#ifdef _DEBUG
	BOOL selected = 0;
	pReader->GetStreamSelection(MF_SOURCE_READER_FIRST_AUDIO_STREAM, &selected);
	ATLASSERT(selected); // no need to select it, active by default

	ATLASSERT(MFGetAttributeUINT32(pUncompressedAudioType, MF_MT_AUDIO_BITS_PER_SAMPLE, 0)==16);
	ATLASSERT(MFGetAttributeUINT32(pUncompressedAudioType, MF_MT_AUDIO_SAMPLES_PER_SECOND, 0)==hz);

	PROPVARIANT pvar;
	pvar.vt = VT_EMPTY;
	hr = pReader->GetPresentationAttribute(MF_SOURCE_READER_MEDIASOURCE, MF_PD_DURATION, &pvar);
#define NANOSEC100 10000 
	ATLASSERT((DWORD)(pvar.hVal.QuadPart/NANOSEC100) >= duration); // unless file is really small
#endif

	UINT32 cbBlockSize = MFGetAttributeUINT32(pUncompressedAudioType, MF_MT_AUDIO_BLOCK_ALIGNMENT, 0);
	ATLASSERT(2==cbBlockSize); // 2 bytes per frame (mono)
    UINT32 cbBytesPerSecond = MFGetAttributeUINT32(pUncompressedAudioType, MF_MT_AUDIO_AVG_BYTES_PER_SECOND, 0);
	// Size of the desired audio clip in bytes:
    DWORD cbAudioClipSize = (DWORD)MulDiv(cbBytesPerSecond, duration, 1000);
	// Round to the audio block size, so that we do not write a partial audio frame.
	cbAudioClipSize = (cbAudioClipSize / cbBlockSize) * cbBlockSize;
	short* pWave = (short*)malloc(cbAudioClipSize);
	LPBYTE prb = (LPBYTE)pWave;

	DWORD cbTotalBytes = 0;
    DWORD cbBuffer = 0;
    BYTE *pAudioData = NULL;
	CComPtr<IMFMediaBuffer> pBuffer;

    // Get audio samples from the source reader.
    while (true)
    {
        DWORD dwFlags = 0;
		//LONGLONG time;

		CComPtr<IMFSample> pSample;

        // Read the next sample.
        hr = pReader->ReadSample(
            (DWORD)MF_SOURCE_READER_FIRST_AUDIO_STREAM,
            0,
            NULL,
            &dwFlags,
            0,//&time,
            &pSample
            );

        if (FAILED(hr)) { break; }

		// I usually read much less than the entire file
		ATLASSERT((dwFlags & (MF_SOURCE_READERF_NEWSTREAM|MF_SOURCE_READERF_NATIVEMEDIATYPECHANGED|
			MF_SOURCE_READERF_CURRENTMEDIATYPECHANGED|MF_SOURCE_READERF_STREAMTICK))==0);

        if (dwFlags & MF_SOURCE_READERF_ENDOFSTREAM)
        {
            //printf("End of input file.\n");
            break;
        }

        if (pSample == NULL)
        {
            ATLTRACE(_T("No sample\n"));
            continue;
        }
        
        // Get a pointer to the audio data in the sample.
		  pBuffer = 0;
        hr = pSample->ConvertToContiguousBuffer(&pBuffer);

        if (!pBuffer) { break; }

		// @@@ except for the first read this is approximately 0.5sec worth MP3 (variable sizes on account of sampling, channels etc)
		// actually it depends on format, WMA is 0.1 second worth (around 10000 bytes)
		// almost the entire 1st chunk read is 0s -- silence?
		  cbBuffer = 0;
        hr = pBuffer->Lock(&pAudioData, NULL, &cbBuffer);
		ATLASSERT(cbBuffer > 1000); // big chunks usually
#if 0
#define MILLISEC100 10000
		printf("sample time %d ms", (int)(time/MILLISEC100));

		//if(next_time)
			//ATLASSERT(next_time==time/MILLISEC100); roundoff errors?
		next_time = time/MILLISEC100 + MulDiv(1000,cbBuffer,cbBytesPerSecond);
		printf(" (next = %d) bytes=%d\n", next_time, cbBuffer);
#endif

        if (FAILED(hr)) { break; }

		  ATLASSERT(cbBuffer);
		ATLASSERT((cbBuffer % cbBlockSize)==0); // whole frames
        // Make sure not to exceed the specified maximum size.
        if (cbAudioClipSize - cbTotalBytes < cbBuffer)
        {
            cbBuffer = cbAudioClipSize - cbTotalBytes;
        }

		  // Write this data to the output
		  memcpy(prb, pAudioData, cbBuffer);
		  prb += cbBuffer;

        // Unlock the buffer.
        hr = pBuffer->Unlock();
        pAudioData = NULL;

        if (FAILED(hr)) { break; }

        // Update running total of audio data.
        cbTotalBytes += cbBuffer;

        if (cbTotalBytes >= cbAudioClipSize)
        {
            break;
        }
    }

	 ATLASSERT(prb <= (LPBYTE)pWave+cbAudioClipSize);

    if (SUCCEEDED(hr))
    {
        ATLTRACE(_T("Wrote %d bytes of audio data.\n"), cbTotalBytes);
    }

    if (pAudioData)
    {
		 ATLASSERT(pBuffer);
        pBuffer->Unlock();
    }

    if (FAILED(hr)) { 
		free(pWave);
		return 0;
	}
	frames = cbTotalBytes/cbBlockSize;

	// sample info in titlebar
	RECT rc;
   GetClientRect(hwnd, &rc);
	// total duration shown is one pixel per sample
	int msec = 1000*rc.right /hz;
	TCHAR buf[100];
	wsprintf(buf, _T("sampling: %d Hz, starting %d msec"), hz, msec);
	SetWindowText(hwnd, buf);

	return pWave;
}
